﻿//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.SV.dll;

using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.SV.Data.Generators.WarehouseAutomationController;
using System;
using System.Diagnostics;
using System.Reflection;
using System.Transactions;
using Produmex.Sbo.Logex.Data.Providers;

namespace AddUpdateData
{
	class Program
    {
        static string CONNECTION_STRING = "Server=bit-des-019;CompanyDB=trunk_pmx;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=manager;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2019;DBCultureInfo=en-US;LicenseServer=bit-des-019:30000";


		/// <summary>
		/// Used for logging
		/// </summary>
		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);


        static void Main(string[] args)
        {
			try
			{
				LogProvider.SetConsoleAppender("WARN");
				Execute();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
			}
			if (Debugger.IsAttached)
			{
				Console.WriteLine("Press <Enter>");
				Console.ReadLine();
			}
		}
		/// <summary>
		/// Executes this instance.
		/// </summary>
		static void Execute()
		{

			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (SboConnection conn = new SboConnection(CONNECTION_STRING))
				{
					conn.Open(); //Open connection to SAP
					Console.WriteLine("Connection is open to database");

					//PmxDbVersionUpdaterProvider dbvup = new PmxDbVersionUpdaterProvider(conn);
					//dbvup.AddUpdateExtension("SV_ISOR",
					//	"SBO sales order im-/exporter for SanderVunderink - IPmxSalesOrderInterface",
					//	typeof(Produmex.Sbo.Logex.SV.Extensions.Interfacing.SboSalesOrderInterface),
					//	Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IINTERFACING_SBOSALESORDER);

					//Console.WriteLine("Creating UDFs");
					//CreatingUDFs(conn);

					//Console.WriteLine("Creating location types");
					//CreatingLocationTypes(conn);

					//Console.WriteLine("Creating pick list types");
					//CreatingPickListTypes(conn);

					//Console.WriteLine("Creating user groups");
					//CreatingUserGroups(conn);

					//Console.WriteLine("Creating logistic carrier items");
					//CreatingLogisticCarriers(conn);
				}

				//Complete transaction
				scope.Complete();
			}

			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (PmxDbConnectionDirect conn = PmxDbConnectionMgr.GetDirectConnection(SboConnectionString.ParseStringToObject(CONNECTION_STRING)))
				{
					conn.Open(); //Open connection to SAP
					Console.WriteLine("Connection is open to database");

					Console.WriteLine("Creating Views");
					CreateUpdateViews(conn);

					//Console.WriteLine("Creating Generators");
					//CreateUpdateExtensionsForReplenishmentGenerator(conn);

					//CreateUpdateExtensionsForPickListRobot(conn);

					//AddPickListController(conn);

					CreateUpdateExtensionsForWarehouseAutomationController(conn);

					//Console.WriteLine("Add custom fields for PMX_* tables");
					//AddCustomFieldsForPmxTables(conn);

					//Console.WriteLine("Add SP ");
					//RunStoredProcedureSqlScript("PMX_SP_ProLaser_TransactionNotification.sql", conn);
				}

				scope.Complete();
			}


			Console.WriteLine("Done ...");
		}
		private static void CreateUpdateExtensionsForWarehouseAutomationController(PmxDbConnectionDirect conn)
		{
			AddUpdateExtension(
				WarehouseAutomationControllerSV.IDs.ExtCode,
				"SanderVunderink - WAC (Warehouse Automation Controller)",
				typeof(WarehouseAutomationControllerSV),
				Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IWAREHOUSEAUTOMATIONCONTROLLER,
				conn);
		}
		private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnection conn)
		{
			PmxExtensionProvider prov = new PmxExtensionProvider(conn);
			PmxExtension extension = null;
			try
			{
				bool newBO = false;
				extension = prov.GetBO(code);
				if (extension == null)
				{
					newBO = true;
					extension = prov.GetNewBO();
					extension.Code = code;
				}
				extension.Name = name;
				extension.ExtensionTypeCode = extensionTypeCode;
				extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
				if (newBO)
				{
					prov.AddBO(extension);
				}
				else
				{
					prov.UpdateBO(extension, false, false);
				}
			}
			finally
			{
				if (extension != null) extension.Dispose();
			}
		}
		static void CreateUpdateViews(PmxDbConnectionDirect conn)
		{
			Assembly plAssembly = typeof(Produmex.Sbo.Logex.SV.SboCommands).Assembly;
			string scriptLocations = "Produmex.Sbo.Logex.SV.Scripts.";

			conn.DbTool.CreateUpdateView("SVE_PMX_PICKLIST_EXPORT", ResourceHelper.ReadResourceContentAsString(plAssembly, scriptLocations + "Views.SVE_PMX_PICKLIST_EXPORT.sql"));
		}
	}
}
